from sasktran2 import pysasktran2 as skinternal
import abc


class ConfigBase(abc.ABC):
    @abc.abstractmethod
    def internal_config(self) -> skinternal.Config:
        pass


class Config(ConfigBase):
    def __init__(self):
        self._nstokes = 1
        self._nthreads = 1

    @property
    def nstokes(self):
        return self._nstokes

    @nstokes.setter
    def nstokes(self, ns: int):
        if ns != 1 and ns != 3:
            raise ValueError('numstokes must be either 1 or 3')

        self._nstokes = ns

    def internal_config(self) -> skinternal.Config:
        config = skinternal.Config(self._nstokes, self._nthreads)

        return config
